#if !defined(RUN_IN_WIN32)
precision mediump float;
#endif

varying vec4 v_vec4Color;
varying vec2 v_vec2UV;

uniform mat4 u_mat4MVP;
uniform sampler2D u_s2dTexture;

// for font
uniform vec2 u_v2FontFlag;
uniform vec4 u_v4FontColor;

// effect flag
// gray: 1, 0
uniform vec2 u_v2EffectFlag;

void main ()
{
    vec4 final_color;
    vec4 baseColor = texture2D(u_s2dTexture, v_vec2UV);
    if (u_v2FontFlag.x == 0.0 || baseColor.a == 0.0) final_color = baseColor * v_vec4Color;
    else final_color = vec4(u_v4FontColor.rgb, u_v4FontColor.a * baseColor.a);

    // rgb converty to gray
    if (u_v2EffectFlag.x == 1.0 && u_v2EffectFlag.y == 0.0)
    {
        float gray_value = dot(final_color.rgb, vec3(0.3, 0.59, 0.11));
        final_color = vec4(gray_value, gray_value, gray_value, final_color.a);
    }
    gl_FragColor = final_color;
}
